#!/usr/bin/python
# -*- coding: utf-8 -*-
"""
© Florian MORTGAT
"""
import os, sys
import re
import time

CLEAR = "\33[H\33[J"
def main ():
	''
if __name__ == "__main__":
	try: main ()
	except KeyboardInterrupt: print "\033[31mLeaving: User typed Ctrl+C.\033[0m"
import random,time,re

animaux="""chats
vaches
vaches laitières
lapins
écureuils
éléphants
souris
tigres
mammouths
cerfs
agneaux
oiseaux
autruches
tortues
zèbres
lynx
scarabées
moustiques
chiens""".split('\n')

objets="""vis sans fin
chaises
paires de gants
porte-avions
chaussettes
écrans plats
fenêtres
couteaux-éplucheurs""".split('\n')

maladies="""cancers de la peau
cancers de l’estomac
cancers du poumon
cas de grippe
rhumes des foins
allergies différentes
syndromes de Helcksmann
cas de salmonellose
maladies mortelles""".split('\n')

rapports="""
un rapport du ministère de l’Intérieur
un rapport de la Cour des comptes
une étude commanditée par l’Assemblée nationale
une expertise récente
le rapport
le résultat de recherches publiés dans la revue Nature
un article paru dans The Lancet
certaines sources
diverses sources
un sondage d’opinion IPSOS
une information non confirmée
une série de chiffres de l’INSEE
une collection de données récentes
une récente étude
le WWF
l’ONG Reporters sans frontières
Médecins sans frontières
""".split('\n')

devises='''$
€
¥
yuans
wons
Francs CFA
Francs suisses
£
livres sterling
'''.split('\n')

noms_communs=animaux+objets+maladies

phrases="""Nous avons vendu NOMBRE OBJETS en 1900-n.
La bandit a avoué le vol de NOMBRE OBJETS en MOIS 1900-n.
Peu importe que l’Allemagne refuse d’acheter nos NOM-COMMUN puisque nos exportations vers l’Italie ont augmenté de 0-100n% depuis 1900-n.
On a dénombré environ PASMAL différentes espèces animales proches des ANIMAUX dans la forêt amazonienne.
Personne ne peut prétendre que les PASMAL d’euros dépensés ces dernières années risque de nous faire perdre notre triple A.
Selon RAPPORT1, sortir du nucléaire coûterait plus de PASMAL milliards d’euros, mais les opposants arguent que ne rien faire se chiffrerait à BEAUCOUP €.
Le prix de l’essence est passé de 1,00n€ à plus de 0-10n€.
D’après RAPPORT1, que vient corroborer RAPPORT2, les délits avec violence ont augmenté de 0-100n% entre 1900-n et l’année dernière.
Le cours du dollar par rapport au yen est passé de QUELQUES0 à QUELQUES1, un choc pour les marchés financiers.
Hier, à la clôture, un euro s’échangeait contre NOMBRE francs CFA.
Ni l’un ni l’autre n’ont confirmé les rumeurs comme quoi le suspect aurait touché 2-500n DEVISE par jour pour son silence.
Le gratte-ciel s’élève à une hauteur majestueuse de 500-1000n mètres.
Le président de la compagnie a perdu plus de NOMBRE $ en bourse l’année dernière.
Nous ne savons pas comment prendre en charge les 2-500n blessés de l’accident.
Cette voiture consomme 0-100n litres aux 100 km.
D’après RAPPORT1, des mesures de radioactivité pouvant aller jusqu’à 0,000n mSv ont été effectuées près du site.
Nous sommes désormais en mesure de transférer vos données personnelles vers notre cloud datacenter à un débit de NOMBRE kb/s !
À en croire RAPPORT1, l’effectif des ANIMAUX dans le monde, espèce classée  menacée, a diminué d’au moins PASMAL individus entre 1900-n et ANNÉE-RÉCENTE.
Comme vous pouvez le voir sur ce graphe, les globules blancs sont rapidement passés de 0-200n/ml à 2-500n/ml.
La comète passera à NOMBRE km de la Terre vers MOIS 1900-n.
Le NASDAQ a enregistré une baisse des importations de OBJETS à hauteur de 0-200n% en 1900-n.""".split('\n')

def nettoyer (*p):
	for liste in p:
		while '' in liste: liste.remove('')
nettoyer (animaux,maladies,noms_communs,rapports,phrases)

formater_grand_nombre = lambda n: re.sub('(\d\d\d)','\\1;psbn&',('%d'%n)[::-1])[::-1]

def get_dico ():
	return {
			'NOMBRE':formater_grand_nombre(random.randint (0,100000000)),
			'NOM-COMMUN':random.choice(noms_communs),
			'ANNÉE-RÉCENTE':random.randint(1990,2013),
			'FUTUR-PROCHE':random.randint(2013,2050),
			'BEAUCOUP':formater_grand_nombre(random.randint(10000, 9999999)),
			'PASMAL':formater_grand_nombre(random.randint(500,10000)),
			'PAS-MAL1':random.randint(500,10000),
			'PAS-MAL2':random.randint(500,10000),
			'PAS-MAL3':random.randint(500,10000),
			'PAS-MAL4':random.randint(500,10000),
			'QUELQUES0':random.randint(500,2000),
			'QUELQUES1':random.randint(500,2000),
			'QUELQUES2':random.randint(500,2000),
			'ANIMAUX':random.choice(animaux),
			'OBJETS':random.choice(objets),
			'DEVISE':random.choice(devises),
			'RAPPORT1':random.choice(rapports),
			'RAPPORT2':random.choice(rapports),
			'ANNÉEn':random.randint(0,2013),
			'1900-n':random.randint(1900,2013),
			'0-10n':random.randint(0,10),
			'0-50n':random.randint(0,50),
			'0-100n':random.randint(0,100),
			'0-200n':random.randint(0,200),
			'2-500n':random.randint(2,500),
			'500-1000n':random.randint(500,1000),
			'1,00n':'%.2f'%(random.random()*10),
			'0,000n':'%.5f'%(random.random()),
			'MOIS':random.choice(('janvier février mars avril mai juin juillet août septembre octobre novembre décembre'.split())),
			}
dico = get_dico ()

for n,i in enumerate(phrases):
	phrases[n]=i=i.replace('%','%%')
	phrases[n]=re.sub('(\\b(?:'+'|'.join (dico.keys())+'))', '%(\\1)s', i)

phrases_hasard = []


for i in xrange (50):
	dico = get_dico ()
	#print CLEAR
	phrases_hasard.append (random.choice(phrases)%dico)
	
HTML_TEMPLATE = '''Content-Type: text/html

<html>
<head>
<title>Nombres</title>
<meta charset="utf-8">
</head>
<body style="margin-left: 10%%; margin-right:50%%; font-size: 18pt;">
<p>%s</p>
</body>
</html>
'''
print HTML_TEMPLATE%('</p>\n<p>'.join (phrases_hasard))

